<!-- Copyright (C) 2017-2020 Linagora

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. -->

<div fxLayout="column">
  <div class="title-about-wrapper margin-bottom-x1">
    <mat-card-title class="light-bold title-about">{{ title }}</mat-card-title>
  </div>

  <ng-template #aboutDeployment>
    <div fxLayout="column" class="when-no-file-selected">
      <mat-card-content fxLayout="column" class="card-content-no-selected-info">
        <p class="msg-about-upload">{{ message }}</p>
        <app-message
          *ngIf="error"
          type="error"
          [msg]="error"
          [isFullWidth]="true"
          class="error-upload"
        ></app-message>
      </mat-card-content>
    </div>

    <mat-card-actions 
      fxFlexFill 
      fxLayoutAlign="end center" 
      class="wrapper-btn-select-file"
    >
      <input 
        #selectFile 
        type="file" 
        name="choose-file-hidden" 
        [accept]="acceptedFileType" 
        (change)="fileChange($event)" 
        required
      >
      <button
        mat-raised-button
        color="primary"
        [disabled]="(percentage < 100 && !error) || (selectedFileInformation && !isFileParsed)" 
        (click)="selectFile.click()"
        class="btn-choose-file text-upper"
      >
        <span fxLayout="row" fxLayoutAlign="center center">
          <fa-icon icon="folder-open" class="icon-x1 margin-right-x1"></fa-icon>
          <span class="choose-file">BROWSE...</span>
          <span [hidden]="!selectFile?.required">*</span>
          <span *ngIf="selectedFileInformation && !isFileParsed" class="margin-left-x1">
            <mat-spinner [diameter]="16" [strokeWidth]="1" class="margin-left-x1"></mat-spinner>
          </span>
        </span>
      </button>
    </mat-card-actions>
  </ng-template>

  <div *ngIf="selectedFileInformation && isFileParsed; else aboutDeployment" fxLayout="column" class="when-selected-file">
    <mat-card-content fxLayout="column" class="card-content-selected-file-info">
      <div fxLayout="column" class="comp-file-info">
        <p fxLayout="column">
          <span class="mat-body-2">File informations</span>
          <span fxLayout="row" fxLayoutAlign="start center" class="wrapper-file-name">
            <span class="file-name">{{ selectedFileInformation.file.name }}</span>
            <button mat-icon-button matTooltip="Cancel" (click)="cancelFile()" class="btn-cancel-file-name margin-right-x1">
              <fa-icon icon="times-circle" class="icon-x1"></fa-icon>
            </button>
          </span>
        </p>
      </div>

      <div *ngIf="updateFileInformation" fxLayout="column" class="edit-information">
        <ng-container [ngTemplateOutlet]="updateFileInformation.templateRef"></ng-container>
      </div>
    </mat-card-content>

    <mat-card-actions fxFlexFill fxLayoutAlign="end center" class="deploy-actions">
      <button
        mat-button
        type="button"
        color="primary"
        (click)="cancelFile()"
        class="btn-cancel-file text-upper margin-right-x1"
      >
        Cancel
      </button>
      <button
        mat-raised-button
        type="button"
        color="primary"
        [disabled]="disabled"
        (click)="uploadFile()"
        class="btn-deploy text-upper"
        >
        <span fxLayout="row" fxLayoutAlign="start center">
          <fa-icon class="margin-right-x1 icon-x2" icon="check"></fa-icon>
          <span class="text-upper deploy-text-btn">Deploy</span>
        </span>
      </button>
    </mat-card-actions>
  </div>
</div>
